<?php

namespace app\admin\controller\help;

use app\common\controller\Backend;

/**
 * 帮扶人申请管理
 *
 * @icon fa fa-circle-o
 */
class HelpApply extends Backend
{
    
    /**
     * HelpApply模型对象
     * @var \app\admin\model\help\HelpApply
     */
    protected $model = null;

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\help\HelpApply;
        $this->view->assign("statusList", $this->model->getStatusList());
    }

    public function import()
    {
        parent::import();
    }
    /**
     * 查看
     */
    public function index()
    {
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                $data = $this->selectpage()->getData();
                if(!$this->request->request('keyValue')) {
                    $data['list'] = array_merge([['id' => 0, 'title' => '无', 'pid' => 0]], $data['list']);
                    $data['total']++;
                }
                return $data;
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();
            /**
             * 获取企业信息
             */
            $where1  = is_sys_admin();
            $list = $this->model
                ->where($where)->where($where1)
                ->order($sort, $order)
                ->paginate($limit);
            foreach ($list as $k => $v) {

            }
            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }
    public function edit($ids=null)
    {
        if($this->request->isPost()) {
            $info = $this->model->where('id', $ids)->find();
            if ($info['status']!='0') $this->error('已审核状态，不能修改');
            if($this->model->where('help_id',$info['help_id'])->where('status','1')->find())
            {
                $this->error('该项目已有帮扶人，不能审核为通过');
            }
            $this->model->where('help_id',$info['help_id'])->where('id','<>',$ids)->update(['status'=>-1]);
            \app\admin\model\help\Help::where('id',$info['help_id'])->update(['apply_user_id'=>$info['user_id']]);
        }

        return parent::edit($ids);

    }

    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */
    

}
